#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <SDL/SDL.h>
#include "EzE.SDL.h"
#include "noidea.lib.h"

SDL_Surface * screen;
//SDL_Surface * mouche;

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================

void dum_func(void)
{
	printf("yo\n");
}

float X,Y,vX,vY;
void other_func (void)
{
	if (vX == 0)	{	vX = 0.01;	}
	if (vY == 0)	{	vY = 0.015;	}
	if (X >= 0.9)	{	X = 0.9;	vX = -0.015;	}
	if (X <= -0.9)	{	X = -0.9;	vX = 0.01;	}
	if (Y >= 0.9)	{	Y = 0.9;	vY = -0.01;	}
	if (Y <= -0.9)	{	Y = -0.9;	vY = 0.015;	}
	X += vX;
	Y += vY;
}

void video_func (void)
{
		EzE_Clear(screen);

		SDL_LockSurface(screen);
		EzE_bresline(screen,EzE_mice.x,  0.90,EzE_mice.y, 0,blue);
		EzE_bresline(screen,EzE_mice.x, -0.90,EzE_mice.y, 0,blue);
		EzE_bresline(screen,EzE_mice.x, 0,EzE_mice.y,  0.90,blue);
		EzE_bresline(screen,EzE_mice.x, 0,EzE_mice.y, -0.90,blue);
		SDL_UnlockSurface(screen);

		//EzE_Stamp(screen,X,Y,mouche);
}

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================

NOIDEA_memory * ram;
NOIDEA_node * nugget;

NOIDEA_node * src;
NOIDEA_node * une;
NOIDEA_node * deux;


void init_func(void)
{

	ram = NOIDEA_seg(malloc(1000),1000);

	src = NOIDEA_schedule(0,&dum_func,10,NOIDEA_alloc(ram,sizeof(NOIDEA_agenda)+sizeof(NOIDEA_node)));
	une = NOIDEA_schedule(src,&video_func,100,NOIDEA_alloc(ram,sizeof(NOIDEA_agenda)+sizeof(NOIDEA_node)));
	deux = NOIDEA_schedule(src,&other_func,100,NOIDEA_alloc(ram,sizeof(NOIDEA_agenda)+sizeof(NOIDEA_node)));

	//mouche = EzE_Format( SDL_LoadBMP("mouche.bmp") );

}

void end_func(void)
{
	//SDL_FreeSurface( mouche );

	NOIDEA_free(ram,NOIDEA_cancel(src,une));
	NOIDEA_free(ram,NOIDEA_cancel(src,deux));
	NOIDEA_free(ram,NOIDEA_cancel(src,src));

	free(ram);
}

//================================================================================================
//================================================================================================
//================================================================================================
//================================================================================================

int main( int argc, char* args[] ) 
{ 
	SDL_Init( SDL_INIT_EVERYTHING );
	screen = SDL_SetVideoMode( 640, 480, 32, SDL_SWSURFACE|SDL_ANYFORMAT );
	SDL_WM_SetCaption( "NOIDEA mush", NULL );

	EzE_Init(screen);
	init_func();

	//SDL_WM_SetIcon(mouche, NULL);

	while (EzE_Loop(screen) == 0)
	{
		float idle = (float)NOIDEA_do(src,EzE_state.tick)/1000;
		EzE_Sleep(idle);
		//SDL_WM_SetCaption( "NOIDEA mush ", NULL );

	}

	end_func();

	SDL_FreeSurface( screen );
	SDL_Quit(); 
	return 0; 
}
